#include "diskpartition.h"
#include "tuple.h"

// compile with: g++ -g -Wall -DDEBUG -o diskTest diskTester.cpp diskpartition.cpp timestamp.cpp

// or: purify -collector=/usr/ccs/bin/ld -g++ /s/ogcc/bin/g++ -g -Wall -DDEBUG -o diskTest diskTester.cpp diskpartition.cpp timestamp.cpp

const int TEST_SIZE = 500;

int main () {

  DiskPartition *dp = new DiskPartition();
  char name[MAX_FILENAME] = "partitions/part1.raw";

  dp->setFilename (name);

  /************************************************************************/

  if (dp->beginAppend () != OK) perror ("bad begin append");

  for (int i = 0; i < TEST_SIZE; i++) {
  
    WITuple *tOut = new WITuple ();
    tOut->unique1 = i;
    StampedTuple *stOut = new StampedTuple ();
    stOut->ATS.setToCurrTime();
    stOut->tuple = tOut;
    stOut->next = NULL;

    if (dp->appendTuple (stOut) != OK) perror ("bad append tuple");
    delete tOut;
    delete stOut;
  }

 
  if (dp->endAppend () != OK) perror ("bad end append");

  /************************************************************************/

  if (dp->beginRead () != OK) perror ("bad begin read");
  for (int i = 0; i < TEST_SIZE; i++) {
    WITuple *tIn = new WITuple ();
    StampedTuple *stIn = new StampedTuple ();
    dp->nextTuple (stIn);
    // cout << "read in tuple with unique " << stIn->tuple->unique1 << endl;
    delete tIn;
    delete stIn;
  }
  if (dp->endRead () != OK) perror ("bad end read");
 
  
  /************************************************************************/

  delete dp;
  
  return 0;


}
