
#include "mempartition.h"
#include "iostream"

// compile with: g++ -g -Wall -DDEBUG mempartition.cpp ht_tester.cpp timestamp.cpp diskpartition.cpp -o httest 

// purify -collector=/usr/ccs/bin/ld -g++ /s/ogcc/bin/g++ -g -Wall -DDEBUG mempartition.cpp ht_tester.cpp timestamp.cpp diskpartition.cpp -o httest 

void main () {

  int count = 10;
  int matchCount = 0;

  char *arena = (char *) new char [count *sizeof (WITuple)];
  char *space = arena;

  cout << "starting tester" << endl;

 MemPartition *partition = new MemPartition ();

 DiskPartition *dp = new DiskPartition ();
 char name[MAX_FILENAME] = "partitions/part1.raw";
 dp->setFilename (name);

 for (int i = 0; i < count; i++) {

   //   WITuple *t1 = new WITuple;
   WITuple *t1 = (WITuple *) space;
   space += sizeof (WITuple);
   t1->unique1 = i;

   StampedTuple *st = new StampedTuple;
   st->ATS.setToCurrTime();
   st->tuple = t1;
   st->next = NULL;

   partition->insert (st);
 }

 for (int i = 0; i < count; i++) {

   WITuple *t1 = new WITuple;
   t1->unique1 = i;

   StampedTuple *st = new StampedTuple;
   st->ATS.setToCurrTime();
   st->tuple = t1;
   st->next = NULL;

   StampedTuple *match;
   partition->probe (st, match);
   if (match) 
     matchCount++;
 }

 if (matchCount == count) 
   cout << "Found all tuples" << endl;
 else
   cout << "Did not find all tuples" << endl;

 int bytesFlushed;
 partition->flush (bytesFlushed);

}
