//=============================================================================
// File: output.h
//    
// Created Tue Apr 11 12:10:10 2000
//    
// Copyright (c) 2000 
// Justin E. Forrester (jforrest@cs.wisc.edu)
// Jonathan Ledlie (ledlie@cs.wisc.edu)
// All Rights Reserved
// 
// Description:
//    output for tuples 
//     
//=============================================================================
#ifndef OUTPUT_H_764
#define OUTPUT_H_764

#include "error.h"
#include "tuple.h"

// make the initial size big to not interfere with 
// XJoin memory allocation and screw up the experiments
#define INITIAL_OUTPUT_SIZE 102400

class Output
{
public:
    // simple output logging routines
    static Status writeTuple(OutputTuple *pTuple, bool isSecondStage);
    static void recordSecondStageRun(void);
    static Status printStats(void);
    static void *statPrinterThreadFunc(void *arg);

private:
    // outputed tuples
    static OutputTuple **tuples;

    // total number of tuples in output
    static int numTuples;

    // total number of tuples 2nd stage joined
    static int numSecondStageTuples;

    // total number of times 2nd stage was invoked
    static int numSecondStageRuns;

    // current max in the vector of output tuples
    static int curMax;

};

#endif
