#!/s/std/bin/perl
use strict;

my $sInfile = $ARGV[0];
my $sOutfile = $ARGV[1];

open(INFILE, $sInfile) || die "Unable to open infile $sInfile";
open(OUTFILE, ">$sOutfile") || die "Unable to open output file $sOutfile";

my $nNumSecondStageRuns = 0;
my $nCounter = 0;
my $nLastNumTuples = -1;

while (<INFILE>)
{
    if (/Memory allowance: (.*)/i)
    {
	print(OUTFILE $1);
    }
    elsif (/Use second stage: Yes/i)
    {
	print(OUTFILE " w/2nd Stage\n");
    }
    elsif (/Use second stage: No/i)
    {
	print(OUTFILE " w/o 2nd Stage\n");
    }
    elsif (/numTuples (.*?) secondStageMatches (.*?) numSecondStageRuns (.*)/i)
    {
	if ($1 != $nLastNumTuples)
	{
	    print(OUTFILE "$nCounter\t$1\n");
	    $nLastNumTuples = $1;
	}
	$nCounter++;
	$nNumSecondStageRuns = $3;
    }
}

#print(OUTFILE "Second Stage Runs $nNumSecondStageRuns\n");

close(INFILE);
close(OUTFILE);
	     
    
