//=============================================================================
// File: timestamp.h
//    
// Created Mon Apr  3 13:49:12 2000
//    
// Copyright (c) 2000 
// Justin E. Forrester, (jforrest@cs.wisc.edu)
// Jonathan Ledlie (ledlie@cs.wisc.edu)
// All Rights Reserved
// 
// Description:
//    timestamp info 
//     
//=============================================================================
#ifndef TIMESTAMP_H_764
#define TIMESTAMP_H_764

#include <sys/time.h>
#include <stdio.h>
#include <limits.h>
class Timestamp
{
private:
    timeval tv;

public:    
    // ctor
    Timestamp(void);

    // copy ctor
    Timestamp(Timestamp &t);

    // general ops
    void print(void);
    
    // updating the time
    void setToCurrTime(void);

    // updating the time
    void setToMaxTime(void);

    // inline comparison ops
    bool operator==(const Timestamp& t) const;
    bool operator!=(const Timestamp& t) const;
    bool operator<(const Timestamp& t) const;
    bool operator>(const Timestamp& t) const;
    bool operator>=(const Timestamp& t) const;
    bool operator<=(const Timestamp& t) const;
};
#endif
