//=============================================================================
// File: tuple.h
//    
// Created Mon Apr  3 13:43:27 2000
//    
// Copyright (c) 2000 
// Justin E. Forrester, (jforrest@cs.wisc.edu)
// Jonathan Ledlie (ledlie@cs.wisc.edu)
// All Rights Reserved
// 
// Description:
//    global tuple related defs
//     
//=============================================================================
#ifndef TUPLE_H_764
#define TUPLE_H_764

#include "timestamp.h"

// max filename length
#define MAX_FILENAME 32

// port that receiver will listen/sender will send to
#define TUPLEPORT 29010

//================================================
// Wisconsin benchmark tuple structure
//================================================
typedef struct __TAGWITUPLE {
    int unique1;
    char pad[284];
} WITuple, *pWITuple;

//================================================
// StampedTuple
//================================================
typedef struct __TAGSTAMPEDTUPLE {
    Timestamp ATS;             // arrival time
    Timestamp DTS;             // departure time
    WITuple *tuple;            // tuple
    __TAGSTAMPEDTUPLE *next;   // for use in hash tables
} StampedTuple, *pStampedTuple;

//================================================
// OutputTuple
//================================================
typedef struct __TAGOUTPUTTUPLE {
    StampedTuple tuple1;
    StampedTuple tuple2;
    Timestamp ts;
} OutputTuple, *pOutputTuple;


#endif
